## clsparse 0.10.2.0

=== CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Advanced Micro Devices, Inc.
# Copyright 2015 Vratis, Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

# We require 2.8.10 because of the added support to download from https URL's
cmake_minimum_required( VERSION 2.8.10 )

if( CMAKE_GENERATOR MATCHES "NMake" )
	option( NMAKE_COMPILE_VERBOSE "Print VERBOSE compile/link msgs to the console" OFF )
	if( NMAKE_COMPILE_VERBOSE )
		set( CMAKE_START_TEMP_FILE "" )
		set( CMAKE_END_TEMP_FILE "" )
		set( CMAKE_VERBOSE_MAKEFILE 1 )
	endif( )
endif( )

# This has to be initialized before the project() command appears
# Set the default of CMAKE_BUILD_TYPE to be release, unless user specifies with -D.  MSVC_IDE does not use CMAKE_BUILD_TYPE
if( NOT MSVC_IDE AND NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." )
endif()

# Check if cmake supports the new VERSION tag for project() commands
# SuperBuild.clSPARSE becomes the name of the project with a particular version
if( POLICY CMP0048 )
  cmake_policy( SET CMP0048 NEW )

  project( SuperBuild.clSPARSE VERSION 0.10.2.0 )
else( )
  project( SuperBuild.clSPARSE )

  # Define a version for the code
  if( NOT DEFINED SuperBuild.clSPARSE_VERSION_MAJOR )
    set( SuperBuild.clSPARSE_VERSION_MAJOR 0 )
  endif( )

  if( NOT DEFINED SuperBuild.clSPARSE_VERSION_MINOR )
    set( SuperBuild.clSPARSE_VERSION_MINOR 10 )
  endif( )

  if( NOT DEFINED SuperBuild.clSPARSE_VERSION_PATCH )
    set( SuperBuild.clSPARSE_VERSION_PATCH 2 )
  endif( )

  if( NOT DEFINED SuperBuild.clSPARSE_VERSION_TWEAK )
    set( SuperBuild.clSPARSE_VERSION_TWEAK 0 )
  endif( )
endif( )

set( SuperBuild.clSPARSE_VERSION "${SuperBuild.clSPARSE_VERSION_MAJOR}.${SuperBuild.clSPARSE_VERSION_MINOR}.${SuperBuild.clSPARSE_VERSION_PATCH}")

list( APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake )

if( MSVC_IDE )
  set( BUILD64 ${CMAKE_CL_64} )
  set_property( GLOBAL PROPERTY USE_FOLDERS TRUE )
else( )
  option( BUILD64 "Build a 64-bit product" ON )
endif( )

# Modify the global find property to help us find libraries like Boost in the correct paths for 64-bit
# Essentially, find_library calls will look for /lib64 instead of /lib; works for windows and linux
if( BUILD64 )
  set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE )
  message( STATUS "64bit build - FIND_LIBRARY_USE_LIB64_PATHS TRUE" )
else( )
  set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS FALSE )
  message( STATUS "32bit build - FIND_LIBRARY_USE_LIB64_PATHS FALSE" )
endif( )

# Various options below on configuring the build, and how to generate the solution files
option( BUILD_clSPARSE "Setup clSPARSE to use all the external dependencies" ON )
option( BUILD_Boost "Install Boost as an external dependency" ON )
option( BUILD_gMock "Install googleMock as an external dependency" ON )
#option( BUILD_clBLAS "Install clBLAS as an external dependency" ON )
option( BUILD_MTX "Download sparse matrix files for bench/test" OFF )
option( BUILD_SAMPLES "Build sample program using clSPARSE lib" OFF )
option( USE_SYSTEM_CL2HPP "Use cl2.hpp installed on system" OFF)
# Query the user for which version of OpenCL they wish to build the library for
set( BUILD_CLVERSION "1.2" CACHE STRING "The version of OpenCL we wish to compile the library against" )
set_property( CACHE BUILD_CLVERSION PROPERTY STRINGS 2.0 1.2 1.1 )


# Comment this out because this does not work yet
set( clSPARSE.Dependencies )
set( clSPARSE.Cmake.Args )
set( clSPARSE.Samples.Cmake.Args )

# If the user selects, download, uncompress, and setup Boost
if( BUILD_Boost )
  message( STATUS "Setting up Boost external..." )
  include( ExternalBoost )
  message( STATUS "BOOST_ROOT configured as: " ${BOOST_ROOT} )
  list( APPEND clSPARSE.Dependencies Boost )
  list( APPEND clSPARSE.Cmake.Args -DBOOST_ROOT=${BOOST_ROOT} )
else( )
  if( WIN32 AND (NOT DEFINED BOOST_ROOT AND NOT DEFINED ENV{BOOST_ROOT}) )
    message( WARNING "BOOST_ROOT should be provided if Boost is not in a default location" )
  else( )
    if( DEFINED BOOST_ROOT )
      list( APPEND clSPARSE.Cmake.Args -DBOOST_ROOT=${BOOST_ROOT} )
    endif( )
  endif( )
endif( )

  # If the user selects, download, uncompress, and setup googleMock
if( BUILD_gMock )
  message( STATUS "Setting up googleMock external..." )
  include( ExternalGmock )
  message( STATUS "GMOCK_ROOT configured as: " ${GMOCK_ROOT} )
  # list( APPEND clSPARSE.Dependencies gMockDebug gMockRelease )
  list( APPEND clSPARSE.Dependencies gMock )
  list( APPEND clSPARSE.Cmake.Args -DGTEST_ROOT=${GMOCK_ROOT} )
else( )
  if( NOT DEFINED GMOCK_ROOT AND NOT DEFINED ENV{GMOCK_ROOT} )
    message( SEND_ERROR "GMOCK_ROOT must be provided if BUILD_gMock is disabled" )
  else( )
    if( NOT DEFINED GMOCK_ROOT )
      set( GMOCK_ROOT "$ENV{GMOCK_ROOT}" )
    endif( )
    list( APPEND clSPARSE.Cmake.Args -DGTEST_ROOT=${GMOCK_ROOT} )
  endif( )
endif( )

# Pass OPENCL_ROOT along to subproject if users provides path
if( DEFINED OPENCL_ROOT )
  list( APPEND clSPARSE.Cmake.Args -DOPENCL_ROOT=${OPENCL_ROOT} )
  list( APPEND clSPARSE.Samples.Cmake.Args -DOPENCL_ROOT=${OPENCL_ROOT} )
endif( )

if( DEFINED NMAKE_COMPILE_VERBOSE )
  list( APPEND clSPARSE.Cmake.Args -DNMAKE_COMPILE_VERBOSE=${NMAKE_COMPILE_VERBOSE} )
endif( )

# If the user selects, download, uncompress, and setup clBLAS
#if( BUILD_clBLAS )
#  message( STATUS "Setting up clBLAS external..." )
#  include( ExternalclBLAS )
#  message( STATUS "CLMATH_BLAS_ROOT configured as: " ${CLMATH_BLAS_ROOT} )
#  list( APPEND clSPARSE.Dependencies clMATH.clblas )
#  list( APPEND clSPARSE.Cmake.Args -DCLMATH_BLAS_ROOT=${CLMATH_BLAS_ROOT} )
#else( )
#  if( NOT DEFINED CLMATH_BLAS_ROOT AND NOT DEFINED ENV{CLMATH_BLAS_ROOT} AND BUILD_clSPARSE )
#    message( SEND_ERROR "CLMATH_BLAS_ROOT must be provided if BUILD_clBLAS is disabled" )
#  else( )
#    if( NOT DEFINED CLMATH_BLAS_ROOT )
#      set( CLMATH_BLAS_ROOT "$ENV{CLMATH_BLAS_ROOT}" )
#    endif( )
#    list( APPEND clSPARSE.Cmake.Args -DCLMATH_BLAS_ROOT=${CLMATH_BLAS_ROOT} )
#  endif( )
#endif( )

# If the user selects, download, uncompress, and setup clBLAS
if( BUILD_MTX )
  message( STATUS "Setting up Matrix Market data external..." )
  include( ExternalMTX )
endif( )

if( BUILD_clSPARSE OR BUILD_SAMPLES )
  include( ExternalProject )

  # Main project
  if( BUILD_clSPARSE )
    message( STATUS "Setting up clSPARSE external..." )

    if ( BUILD_SAMPLES )
      # If the user elects to build samples, then we must build and install clSPARSE
      # The install location is set as a subdirectory of the SuperBuild
      ExternalProject_Add(
        clSPARSE
        DEPENDS ${clSPARSE.Dependencies}
        SOURCE_DIR ${PROJECT_SOURCE_DIR}/src
        BINARY_DIR clSPARSE-build
        INSTALL_DIR clSPARSE-package
        CMAKE_ARGS ${clSPARSE.Cmake.Args} -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
        -DBUILD_CLVERSION=${BUILD_CLVERSION} -DCMAKE_INSTALL_PREFIX=<INSTALL_DIR>
        -DUSE_SYSTEM_CL2HPP:BOOL=${USE_SYSTEM_CL2HPP}
      )
    else( )
      # If the user does not want to build samples, then build clSPARSE but don't automatically
      # install it
      ExternalProject_Add(
        clSPARSE
        DEPENDS ${clSPARSE.Dependencies}
        SOURCE_DIR ${PROJECT_SOURCE_DIR}/src
        BINARY_DIR clSPARSE-build
        CMAKE_ARGS ${clSPARSE.Cmake.Args} -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
        -DBUILD_CLVERSION=${BUILD_CLVERSION} -DUSE_SYSTEM_CL2HPP:BOOL=${USE_SYSTEM_CL2HPP}
        INSTALL_COMMAND ""
      )
    endif( )

  endif( )

  # Our goal with samples is to demonstrate two things
  # 1.  Demonstrate what simple clSPARSE code looks like to set up and execute common functionality
  # 2.  Demonstrate how an external program would find and link clSPARSE
  if ( BUILD_SAMPLES )
    message( STATUS "Setting up sample programs ...")
    ExternalProject_Get_Property( clSPARSE install_dir )

    ExternalProject_Add(
      clSPARSE-samples
      DEPENDS clSPARSE
      SOURCE_DIR ${PROJECT_SOURCE_DIR}/samples
      BINARY_DIR clSPARSE-samples-build
      CMAKE_ARGS ${clSPARSE.Samples.Cmake.Args} -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
      -DBUILD_CLVERSION=${BUILD_CLVERSION} -DBUILD64=${BUILD64} -DCMAKE_PREFIX_PATH=${install_dir}
      -DUSE_SYSTEM_CL2HPP:BOOL=${USE_SYSTEM_CL2HPP}
      EXCLUDE_FROM_ALL 1
      INSTALL_COMMAND ""
    )
  endif( )
endif( )

=== samples/CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Vratis, Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

cmake_minimum_required( VERSION 2.8.12 )
project(samples)

message( STATUS "BUILDING EXAMPLES")
message( STATUS "BUILD64: ${BUILD64}")

set( CLSPARSE_LIB_SUFFIX "")
if( ${BUILD64} )
   set( CLSPARSE_LIB_SUFFIX "64")
   set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE )
endif( )

list( APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

# Find clSPARSE library
find_package( clSPARSE REQUIRED CONFIG )
message( STATUS "clSPARSE INCLUDES = ${clSPARSE_INCLUDE_DIR}")

# Query the user for which version of OpenCL they wish to build the library for
set( BUILD_CLVERSION "1.2" CACHE STRING "The version of OpenCL we wish to compile the samples against" )
set_property( CACHE BUILD_CLVERSION PROPERTY STRINGS 2.0 1.2 1.1 )
message( STATUS "clSPARSE samples are building using CL interface ='${BUILD_CLVERSION}'" )

# Find OpenCL
find_package( OpenCL ${BUILD_CLVERSION} REQUIRED )
message( STATUS "OPENCL_INCLUDE_DIRS = ${OPENCL_INCLUDE_DIRS}")

if( BUILD_CLVERSION VERSION_EQUAL "2.0" )
    add_definitions( -DBUILD_CLVERSION=200 )
elseif( BUILD_CLVERSION VERSION_EQUAL "1.2" )
    add_definitions( -DBUILD_CLVERSION=120 )
elseif( BUILD_CLVERSION VERSION_EQUAL "1.1" )
    add_definitions( -DBUILD_CLVERSION=110 )
endif( )

if(NOT USE_SYSTEM_CL2HPP)
    include(BuildCL2HPP)
endif(NOT USE_SYSTEM_CL2HPP)

include_directories(
    ${OPENCL_INCLUDE_DIRS}
    ${CL2HPP_INCLUDE_DIRECTORY}
    )

# No we are ready to generate the samples

set (SAMPLES_CPP
sample-initialization
sample-axpy
sample-spmv
sample-cg
)

set (SAMPLES_C
sample-initialization-c
sample-norm1-c
)

set(EXAMPLE_TARGETS)

foreach( sample ${SAMPLES_CPP} )
  add_executable( ${sample} ${sample}.cpp)
  target_link_libraries( ${sample} clSPARSE ${CMAKE_DL_LIBS} ${OPENCL_LIBRARIES} )
  if( CMAKE_COMPILER_IS_GNUCXX OR ( CMAKE_CXX_COMPILER_ID MATCHES "Clang" ) )
   target_compile_options( ${sample} PUBLIC -std=c++11 )
  endif( )
  set_target_properties( ${sample} PROPERTIES VERSION ${clSPARSE_VERSION} )
  set_target_properties( ${sample} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
  set_property( TARGET ${sample} PROPERTY FOLDER "Samples" )
  # collect targets for installation
  list(APPEND EXAMPLE_TARGETS ${sample})
  if(NOT USE_SYSTEM_CL2HPP)
      add_dependencies(${sample} cl2hpp)
  endif(NOT USE_SYSTEM_CL2HPP)
endforeach( )

foreach( sample ${SAMPLES_C} )
  add_executable( ${sample} ${sample}.c)
  target_link_libraries( ${sample} clSPARSE ${OPENCL_LIBRARIES})
  set_target_properties( ${sample} PROPERTIES VERSION ${clSPARSE_VERSION} )
  set_target_properties( ${sample} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
  set_property( TARGET ${sample} PROPERTY FOLDER "Samples" )
# collect targets for installation
  list(APPEND EXAMPLE_TARGETS ${sample})
  if(NOT USE_SYSTEM_CL2HPP)
      add_dependencies(${sample} cl2hpp)
  endif(NOT USE_SYSTEM_CL2HPP)
endforeach( )

#Installation step
message(STATUS "DEST ${CMAKE_PREFIX_PATH}/Samples")
message(STATUS "TARGETS ${EXAMPLE_TARGETS}")
install(TARGETS ${EXAMPLE_TARGETS} DESTINATION  ${CMAKE_PREFIX_PATH}/Samples)

=== src/CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

# We require 2.8.12 for linking libraries we specify PRIVATE, INTERFACE and
# PUBLIC keywords
cmake_minimum_required( VERSION 2.8.12 )

if( CMAKE_GENERATOR MATCHES "NMake" )
	option( NMAKE_COMPILE_VERBOSE "Print VERBOSE compile/link msgs to the console" OFF )
	if( NMAKE_COMPILE_VERBOSE )
		set( CMAKE_START_TEMP_FILE "" )
		set( CMAKE_END_TEMP_FILE "" )
		set( CMAKE_VERBOSE_MAKEFILE 1 )
	endif( )
endif( )

# This has to be initialized before the project() command appears
# Set the default of CMAKE_BUILD_TYPE to be release, unless user specifies with -D.  MSVC_IDE does not use CMAKE_BUILD_TYPE
if( NOT MSVC_IDE AND NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." )
endif()

# Check if cmake supports the new VERSION tag for project() commands
# clSPARSE becomes the name of the project with a particular version
if( POLICY CMP0048 )
	cmake_policy( SET CMP0048 NEW )
	project( clSPARSE VERSION 0.10.2.0 LANGUAGES C CXX )
else( )
	project( clSPARSE C CXX )
	# Define a version for the code
	if( NOT DEFINED clSPARSE_VERSION_MAJOR )
		set( clSPARSE_VERSION_MAJOR 0 )
	endif( )

	if( NOT DEFINED clSPARSE_VERSION_MINOR )
		set( clSPARSE_VERSION_MINOR 10 )
	endif( )

	if( NOT DEFINED clSPARSE_VERSION_PATCH )
		set( clSPARSE_VERSION_PATCH 2 )
	endif( )

	if( NOT DEFINED clSPARSE_VERSION_TWEAK )
		set( clSPARSE_VERSION_TWEAK 0 )
	endif( )

	set( clSPARSE_VERSION "${clSPARSE_VERSION_MAJOR}.${clSPARSE_VERSION_MINOR}.${clSPARSE_VERSION_PATCH}.${clSPARSE_VERSION_TWEAK}")
endif( )

message( STATUS "clSPARSE_VERSION= ${clSPARSE_VERSION}" )
message( STATUS "CMAKE_BUILD_TYPE= ${CMAKE_BUILD_TYPE}" )

# This is incremented when the ABI to the library changes
set( clSPARSE_SOVERSION 1 )

list( APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake )

# This option only works for make/nmake and the ninja generators, but no reason it shouldn't be on all the time
# This tells cmake to create a compile_commands.json file that can be used with clang tooling or vim
set( CMAKE_EXPORT_COMPILE_COMMANDS ON )

# On windows, it's convenient to change the default install prefix such that it does NOT point to 'program files'
# Need to check out CMAKE_RUNTIME_OUTPUT_DIRECTORY variable, and see if that eliminates the need to modify install path
if( WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
	set( CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories" FORCE )
endif( )

if( MSVC_IDE )
	set( clSPARSE_BUILD64 ${CMAKE_CL_64} )
	set_property( GLOBAL PROPERTY USE_FOLDERS TRUE )
else()
	option( clSPARSE_BUILD64 "Build a 64-bit product" ON )
endif()

# These variables are meant to contain string which should be appended to the installation paths
# of library and executable binaries, respectively.  They are meant to be user configurable/overridable.
set( SUFFIX_LIB_DEFAULT "" )
set( SUFFIX_BIN_DEFAULT "" )

# Modify the global find property to help us find libraries like Boost in the correct paths for 64-bit
# Essentially, find_library calls will look for /lib64 instead of /lib; works for windows and linux
if( clSPARSE_BUILD64 )
	set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE )
	message( STATUS "64bit build - FIND_LIBRARY_USE_LIB64_PATHS TRUE" )

	if( NOT APPLE )
		set( SUFFIX_LIB_DEFAULT "64" )
	endif( )
else( )
	set_property( GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS FALSE )
	message( STATUS "32bit build - FIND_LIBRARY_USE_LIB64_PATHS FALSE" )
endif( )

set( SUFFIX_LIB ${SUFFIX_LIB_DEFAULT} CACHE STRING "String to append to 'lib' install path" )
set( SUFFIX_BIN ${SUFFIX_BIN_DEFAULT} CACHE STRING "String to append to 'bin' install path" )

# Currently, linux has a problem outputing both narrow and wide characters,
# which happens in our client because openCL only supports narrow characters
if( WIN32 )
	option( BUILD_UNICODE "Create a solution that compiles clSPARSE with Unicode Support" ON )
	if( BUILD_UNICODE )
		message( STATUS "UNICODE build" )
	endif( )
else()
	set( BUILD_UNICODE OFF )
	message( STATUS "UNICODE disabled on linux" )
endif()

# avoid warning on newer cmake versions
if( APPLE )
  set( CMAKE_MACOSX_RPATH 0 )
endif( )

# Set common compile and link options
if( MSVC )
	# Following options for nMake
	message( STATUS "Detected MSVS Ver: " ${MSVC_VERSION} )

	# CMake uses huge stack frames for windows, for some reason.  We remove.
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}" )
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}" )
	string( REGEX REPLACE "/STACK:[0-9]+" "" CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}" )

	if( BUILD_StripSymbols )
		string( REGEX REPLACE "/Zi" "" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}" )
	endif()
elseif( CMAKE_COMPILER_IS_GNUCC )
	message( STATUS "Detected GNU compiler collection" )

	if( clSPARSE_BUILD64 )
		set( CMAKE_CXX_FLAGS "-m64 ${CMAKE_CXX_FLAGS}" )
		set( CMAKE_C_FLAGS "-m64 ${CMAKE_C_FLAGS}" )
	else( )
		set( CMAKE_CXX_FLAGS "-m32 ${CMAKE_CXX_FLAGS}" )
		set( CMAKE_C_FLAGS "-m32 ${CMAKE_C_FLAGS}" )
	endif( )
else( )
	message( AUTHOR_WARNING "Compiler not recognized.  Using default flags." )
endif( )

# If UNICODE is defined, pass extra definitions into
if( BUILD_UNICODE )
	add_definitions( "/DUNICODE /D_UNICODE" )
endif( )

# Print out compiler flags for viewing/debug
message( STATUS "CMAKE_CXX_COMPILER flags: " ${CMAKE_CXX_FLAGS} )
message( STATUS "CMAKE_CXX_COMPILER debug flags: " ${CMAKE_CXX_FLAGS_DEBUG} )
message( STATUS "CMAKE_CXX_COMPILER release flags: " ${CMAKE_CXX_FLAGS_RELEASE} )
message( STATUS "CMAKE_CXX_COMPILER relwithdebinfo flags: " ${CMAKE_CXX_FLAGS_RELWITHDEBINFO} )
message( STATUS "CMAKE_EXE_LINKER link flags: " ${CMAKE_EXE_LINKER_FLAGS} )

# Query the user for which version of OpenCL they wish to build the library for
set( BUILD_CLVERSION "1.2" CACHE STRING "The version of OpenCL we wish to compile the library against" )
set_property( CACHE BUILD_CLVERSION PROPERTY STRINGS 2.0 1.2 1.1 )
message( STATUS "clSPARSE is building using CL interface ='${BUILD_CLVERSION}'" )

# clSPARSE library requires OpenCL
# A standard FindOpenCL.cmake module ships with cmake 3.1, but we supply our own until 3.1 becomes more $
find_package( OpenCL ${BUILD_CLVERSION} REQUIRED )

# configure a header file to pass the CMake version settings to the source, and package the header files in the output archive
message( STATUS "PROJECT SRC DIR = ${PROJECT_SOURCE_DIR}")
configure_file( "${PROJECT_SOURCE_DIR}/include/clSPARSE-version.h.in" "${PROJECT_BINARY_DIR}/include/clSPARSE-version.h" )
install( FILES
			"${PROJECT_BINARY_DIR}/include/clSPARSE-version.h"
			"include/clSPARSE.h"
			"include/clSPARSE-1x.h"
			"include/clSPARSE-2x.h"
    	"include/clSPARSE-xx.h"
			"include/clSPARSE-error.h"
		DESTINATION
			"./include" )

option( BUILD_TESTS "Build clSPARSE unit tests; requires Boost & googletest" ON )
option( BUILD_BENCHMARKS "Build clSPARSE benchmarks" ON )

if(NOT USE_SYSTEM_CL2HPP)
    include(BuildCL2HPP)
endif(NOT USE_SYSTEM_CL2HPP)

add_subdirectory( library )
add_subdirectory( clsparseTimer )

if( BUILD_BENCHMARKS )
	add_subdirectory( benchmarks )
endif( )

if( BUILD_TESTS )
	add_subdirectory( tests )
endif( )

# Depending on whether we are building for 64 or 32 bit, construct common paths and names that subdirectories can reference for their use
if( clSPARSE_BUILD64 )
	set( CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${clSPARSE_VERSION}-${CMAKE_HOST_SYSTEM_NAME}-x64" )
	set( INCLUDE_DIR include )
else( )
	set( CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${clSPARSE_VERSION}-${CMAKE_HOST_SYSTEM_NAME}-x32" )
	set( INCLUDE_DIR include )
endif( )

# The following code is setting variables to control the behavior of CPack to generate our
if( WIN32 )
	set( CPACK_SOURCE_GENERATOR "ZIP" )
	set( CPACK_GENERATOR "ZIP" )
else( )
	set( CPACK_SOURCE_GENERATOR "TGZ" )
	set( CPACK_GENERATOR "TGZ" )
endif( )

set( CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${clSPARSE_VERSION}-${CMAKE_HOST_SYSTEM_NAME}-Source")
# set( CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.txt")
set( CPACK_PACKAGE_VERSION_MAJOR ${clSPARSE_VERSION_MAJOR} )
set( CPACK_PACKAGE_VERSION_MINOR ${clSPARSE_VERSION_MINOR} )
set( CPACK_PACKAGE_VERSION_PATCH ${clSPARSE_VERSION_PATCH} )
set( CPACK_PACKAGE_VERSION_TWEAK ${clSPARSE_VERSION_TWEAK} )
set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "OpenCL SPARSE library package")
set( CPACK_PACKAGE_VENDOR "AMD")
set( CPACK_SOURCE_IGNORE_FILES "/\\\\.git/;/\\\\.hg/;/\\\\.svn/;" )

# Define all variables that influence CPack before including CPack, such as install targets
include( CPack )

=== src/benchmarks/CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################


message( STATUS "Configuring benchmarks sub-dir" )

# If user provides a specific boost path through command line, make sure to
# use that
if( DEFINED BOOST_ROOT OR DEFINED ENV{BOOST_ROOT} )
  set( Boost_NO_SYSTEM_PATHS ON )
  set( Boost_NO_BOOST_CMAKE ON )
endif( )

# set( Boost_DEBUG ON )
set( Boost_USE_MULTITHREADED ON )
set( Boost_DETAILED_FAILURE_MSG ON )
set( Boost_ADDITIONAL_VERSIONS 1.60.0 1.60 1.59.0 1.59 1.58.0 1.58 1.57.0 1.57 )

# On windows, Boost prefers to link statically unless the user defines BOOST_ALL_DYN_LINK
# Therefore, we prefer linking  static libs first to avoid extra #defines
set( Boost_USE_STATIC_LIBS ON )
find_package( Boost COMPONENTS program_options filesystem regex system )

# If static libraries are not found, search again for shared libraries
if( NOT Boost_FOUND )
  set( Boost_USE_STATIC_LIBS OFF )
  find_package( Boost COMPONENTS program_options filesystem regex system )
endif( )

if( CMAKE_COMPILER_IS_GNUCXX OR ( CMAKE_CXX_COMPILER_ID MATCHES "Clang" ) )
  add_definitions( -std=c++11 )
endif( )

include_directories(
  ${CL2HPP_INCLUDE_DIRECTORY}
  ${Boost_INCLUDE_DIRS}
)

add_subdirectory( clsparse-bench )

# Only enable/build the cuda benchmark if CUDA is detected on the platform
find_package( CUDA )

if( CUDA_FOUND )
  add_subdirectory( cusparse-bench )
endif( )

=== src/clsparseTimer/CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

include( GenerateExportHeader )

# List the names of the files to compile for the external client . . .
set( clsparseTimer.Source
	clsparseTimer-host.cpp
	clsparseTimer-device.cpp
	clsparseTimer-extern.cpp
 )

# Windows only uses dllmain
if( MSVC )
	list( APPEND clsparseTimer.Source dllmain.cpp )
endif( )

set( clsparseTimer.Headers
	${PROJECT_SOURCE_DIR}/include/clSPARSE.h
	${PROJECT_SOURCE_DIR}/include/clsparseTimer.hpp
	${PROJECT_SOURCE_DIR}/include/clsparseTimer-extern.hpp
	clsparseTimer-host.hpp
	clsparseTimer-device.hpp
 )

set( clsparseTimer.Files ${clsparseTimer.Source} ${clsparseTimer.Headers} )

if( CMAKE_COMPILER_IS_GNUCXX OR ( CMAKE_CXX_COMPILER_ID MATCHES "Clang" ) )
  add_definitions( -std=c++11 )
endif( )

if( BUILD_CLVERSION VERSION_EQUAL "2.0" )
    add_definitions( -DBUILD_CLVERSION=200 )
elseif( BUILD_CLVERSION VERSION_EQUAL "1.2" )
    add_definitions( -DBUILD_CLVERSION=120 )
elseif( BUILD_CLVERSION VERSION_EQUAL "1.1" )
    add_definitions( -DBUILD_CLVERSION=110 )
endif( )

# Include standard OpenCL headers
include_directories(
	${OPENCL_INCLUDE_DIRS}
    ${CL2HPP_INCLUDE_DIRECTORY}
	${PROJECT_BINARY_DIR}/include
	${PROJECT_BINARY_DIR}/library
	${PROJECT_BINARY_DIR}/clsparseTimer
	../include
	)

add_library( clsparseTimer SHARED ${clsparseTimer.Files} )
set_target_properties( clsparseTimer PROPERTIES VERSION ${clSPARSE_VERSION} )
set_target_properties( clsparseTimer PROPERTIES SOVERSION ${clSPARSE_SOVERSION} )
set_target_properties( clsparseTimer PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
set_target_properties( clsparseTimer PROPERTIES CXX_VISIBILITY_PRESET hidden)
set_target_properties( clsparseTimer PROPERTIES VISIBILITY_INLINES_HIDDEN ON)
target_link_libraries( clsparseTimer ${OPENCL_LIBRARIES} )

if(NOT USE_SYSTEM_CL2HPP)
    add_dependencies(clsparseTimer cl2hpp)
endif(NOT USE_SYSTEM_CL2HPP)

# Package that helps me set visibility for function names exported from shared library
GENERATE_EXPORT_HEADER( clsparseTimer )

if( UNIX AND NOT APPLE )
	# This library dependency is brought in by the high precision timer available in linux
	target_link_libraries( clsparseTimer -lrt )
endif( )

# CPack configuration; include the executable into the package
install( TARGETS clsparseTimer
  RUNTIME DESTINATION bin${SUFFIX_BIN}
  LIBRARY DESTINATION lib${SUFFIX_LIB}
  ARCHIVE DESTINATION lib${SUFFIX_LIB}
)

install( FILES
  ${CMAKE_CURRENT_BINARY_DIR}/clsparsetimer_export.h
  DESTINATION
    include
)

=== src/library/CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Advanced Micro Devices, Inc.
# Copyright 2015 Vratis, Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

include( GenerateExportHeader )

# clSPARSE library requires clBLAS
# find_package( clBLAS REQUIRED )

if( CMAKE_COMPILER_IS_GNUCXX OR ( CMAKE_CXX_COMPILER_ID MATCHES "Clang" ) )
  add_definitions( -std=c++11 )
endif( )

if( BUILD_CLVERSION VERSION_EQUAL "2.0" )
    add_definitions( -DBUILD_CLVERSION=200 )
elseif( BUILD_CLVERSION VERSION_EQUAL "1.2" )
    add_definitions( -DBUILD_CLVERSION=120 )
elseif( BUILD_CLVERSION VERSION_EQUAL "1.1" )
    add_definitions( -DBUILD_CLVERSION=110 )
endif( )

#add_definitions( -D__CL_ENABLE_EXCEPTIONS )

set( clSPARSE_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/include )

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CL2HPP_INCLUDE_DIRECTORY}
  ${clSPARSE_INCLUDE_DIRS}
# ${clBLAS_INCLUDE_DIRS}
  ${OPENCL_INCLUDE_DIRS}
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_BINARY_DIR}/clsparseTimer
)

set(ocl_kernels_file_name ${PROJECT_BINARY_DIR}/include/kernels/source-provider.cpp)
add_custom_command(
  OUTPUT "${ocl_kernels_file_name}"
  COMMAND ${CMAKE_COMMAND}
    -DCL_DIR="${CMAKE_CURRENT_SOURCE_DIR}/kernels"
    -DOUTPUT="${ocl_kernels_file_name}"
    -P "${PROJECT_SOURCE_DIR}/cmake/cl2cpp_raw.cmake"
)

# List the names of common files to compile across all platforms
set( clSPARSE.source.cl
  kernels/csrmv_general.cl
  kernels/csrmv_adaptive.cl
  kernels/csrmm_general.cl
  kernels/control.cl
  kernels/blas1.cl
  kernels/reduce.cl
  kernels/dot.cl
  kernels/atomic_reduce.cl
  kernels/elementwise_transform.cl
  kernels/matrix_utils.cl
  kernels/sort_by_key_common.cl
  kernels/sort_by_key_int.cl
  kernels/sort_by_key_uint.cl
  kernels/scan.cl
  kernels/reduce_by_key.cl
  kernels/conversion_utils.cl
  kernels/SpGEMM_computeNnzCt_kernels.cl
  kernels/SpGEMM_ESC_0_1_kernels.cl
  kernels/SpGEMM_ESC_2heap_kernels.cl
  kernels/SpGEMM_ESC_bitonic_kernels.cl
  kernels/SpGEMM_EM_kernels.cl
  kernels/SpGEMM_copyCt2C_kernels.cl
)

set( clSPARSE.source.cpp
  clsparse-init.cpp
  io/mm-reader.cpp
)

set( clSPARSE.source.internal
  internal/clsparse-control.cpp
  internal/clsparse-validate.cpp
  internal/kernel-cache.cpp
  internal/ocl-type-traits.cpp
  internal/kernel-wrap.cpp
  internal/data-types/csr-meta.cpp
)

set( clSPARSE.source.transform
  transform/clsparse-csr2dense.cpp
  transform/clsparse-coo2csr.cpp
  transform/clsparse-csr2coo.cpp
  transform/sort-by-key.cpp
  transform/clsparse-dense2csr.cpp
)

set( clSPARSE.source.blas1
  blas1/cldense-axpy.cpp
  blas1/cldense-axpby.cpp
  blas1/cldense-scale.cpp
  blas1/cldense-reduce.cpp
  blas1/cldense-dot.cpp
  blas1/reduce-operators.cpp
  blas1/cldense-nrm1.cpp
  blas1/cldense-nrm2.cpp
  blas1/elementwise-transform.cpp
  blas1/elementwise-operators.cpp
)

set( clSPARSE.source.blas2
  blas2/clsparse-csrmv.cpp
)

set( clSPARSE.source.blas3
  blas3/clsparse-csrmm.cpp
  blas3/clsparse-spm-spm.cpp
)

set( clSPARSE.source.solvers
  solvers/solver-control.cpp
  solvers/conjugate-gradients.cpp
  solvers/biconjugate-gradients-stabilized.cpp
)

set( clSPARSE.Headers.public
  ../include/clSPARSE.h
  ../include/clSPARSE-1x.h
  ../include/clSPARSE-2x.h
  ../include/clSPARSE-error.h
  ${PROJECT_BINARY_DIR}/include/clSPARSE-version.h
)

set( clSPARSE.Headers.private
  include/clSPARSE-1x.hpp
  include/clSPARSE-2x.hpp
  include/clSPARSE-private.hpp
)

set( clSPARSE.Headers.blas1
  blas1/reduce.hpp
  blas1/atomic-reduce.hpp
  blas1/reduce-operators.hpp
  blas1/commons.hpp
  blas1/cldense-dot.hpp
  blas1/cldense-scale.hpp
  blas1/cldense-axpy.hpp
  blas1/cldense-axpby.hpp
  blas1/cldense-nrm1.hpp
  blas1/cldense-nrm2.hpp
  blas1/elementwise-transform.hpp
  blas1/elementwise-operators.hpp
)

set( clSPARSE.Headers.blas2
  blas2/clsparse-csrmv.hpp
  blas2/csrmv-vector.hpp
  blas2/csrmv-adaptive.hpp
)

set( clSPARSE.Headers.blas3
  blas3/clsparse-csrmm.hpp
)

set( clSPARSE.Headers.solvers
  solvers/solver-control.hpp
  solvers/preconditioners/preconditioner.hpp
  solvers/preconditioners/diagonal.hpp
  solvers/preconditioners/void.hpp
  solvers/preconditioners/preconditioner_utils.hpp
  solvers/conjugate-gradients.hpp
  solvers/biconjugate-gradients-stabilized.hpp
)

set( clSPARSE.Headers.internal
  internal/clsparse-internal.hpp
  internal/clsparse-control.hpp
  internal/clsparse-validate.hpp
  internal/source-provider.hpp
  internal/kernel-cache.hpp
  internal/ocl-type-traits.hpp
  internal/kernel-wrap.hpp
  internal/data-types/clvector.hpp
  internal/data-types/clarray.hpp
  internal/data-types/clarray-base.hpp
  internal/data-types/reference-base.hpp
  internal/data-types/iterator-base.hpp
  internal/data-types/csr-meta.hpp
  ${ocl_kernels_file_name}
)

set ( clSPARSE.Headers.transform
  transform/sort-by-key.hpp
  transform/scan.hpp
  transform/reduce-by-key.hpp
  transform/conversion-utils.hpp
)


# source_group( kernels REGULAR_EXPRESSION ".*cl$" )
# Group header files into nice bundles
source_group( "Header Files\\Kernels" FILES ${clSPARSE.source.cl} )
source_group( "Header Files\\Public" FILES ${clSPARSE.Headers.public} )
source_group( "Header Files\\Private" FILES ${clSPARSE.Headers.private} )
source_group( "Header Files\\Blas1" FILES ${clSPARSE.Headers.blas1} )
source_group( "Header Files\\Blas2" FILES ${clSPARSE.Headers.blas2} )
source_group( "Header Files\\Blas3" FILES ${clSPARSE.Headers.blas3} )
source_group( "Header Files\\Solvers" FILES ${clSPARSE.Headers.solvers} )
source_group( "Header Files\\Internal" FILES ${clSPARSE.Headers.internal} )
source_group( "Header Files\\Transform" FILES ${clSPARSE.Headers.transform} )

# Group source files into nice bundles
source_group( "Source Files\\Internal" FILES ${clSPARSE.source.internal} )
source_group( "Source Files\\Transform" FILES ${clSPARSE.source.transform} )
source_group( "Source Files\\Blas1" FILES ${clSPARSE.source.blas1} )
source_group( "Source Files\\Blas2" FILES ${clSPARSE.source.blas2} )
source_group( "Source Files\\Blas3" FILES ${clSPARSE.source.blas3} )
source_group( "Source Files\\Solvers" FILES ${clSPARSE.source.solvers} )

if( CMAKE_COMPILER_IS_GNUCXX )
    add_definitions( -pedantic )
endif( )

# Query the user for which version of OpenCL they wish to build the library for
set( clSPARSE_LIBRARY_TYPE "SHARED" CACHE STRING "Build the clSPARSE library as SHARED or STATIC build types" )
set_property( CACHE clSPARSE_LIBRARY_TYPE PROPERTY STRINGS SHARED STATIC )
message( STATUS "clSPARSE will build as a '${clSPARSE_LIBRARY_TYPE}' library" )

# Query the user for which version of OpenCL they wish to build the library for
set( clSPARSE_INDEX_SIZEOF "4" CACHE STRING "Compile the library to assume this index byte size (64-bit indices not implemented yet)" )
set_property( CACHE clSPARSE_INDEX_SIZEOF PROPERTY STRINGS 4 )
message( STATUS "clSPARSE will build with '${clSPARSE_INDEX_SIZEOF}' index bitness" )

add_library( clSPARSE ${clSPARSE_LIBRARY_TYPE}
  ${clSPARSE.source.cpp}
  ${clSPARSE.source.internal}
  ${clSPARSE.source.transform}
  ${clSPARSE.source.blas1}
  ${clSPARSE.source.blas2}
  ${clSPARSE.source.blas3}
  ${clSPARSE.source.solvers}
  ${clSPARSE.Headers.public}
  ${clSPARSE.Headers.private}
  ${clSPARSE.Headers.blas1}
  ${clSPARSE.Headers.blas2}
  ${clSPARSE.Headers.blas3}
  ${clSPARSE.Headers.solvers}
  ${clSPARSE.Headers.internal}
  ${clSPARSE.Headers.transform}
  ${clSPARSE.source.cl}
  )

if(NOT USE_SYSTEM_CL2HPP)
    add_dependencies(clSPARSE cl2hpp)
endif(NOT USE_SYSTEM_CL2HPP)

# PRIVATE linking prevents transitive library linking of dependent libraries
target_link_libraries( clSPARSE PRIVATE ${OPENCL_LIBRARIES} ${CMAKE_DL_LIBS} ) #${clBLAS_LIBRARIES} )

set_target_properties( clSPARSE PROPERTIES VERSION ${clSPARSE_VERSION} SOVERSION ${clSPARSE_SOVERSION} )
set_target_properties( clSPARSE PROPERTIES DEBUG_POSTFIX d )
set_target_properties( clSPARSE PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
set_target_properties( clSPARSE PROPERTIES CXX_VISIBILITY_PRESET hidden)
set_target_properties( clSPARSE PROPERTIES VISIBILITY_INLINES_HIDDEN ON)
target_compile_definitions( clSPARSE PUBLIC CLSPARSE_INDEX_SIZEOF=${clSPARSE_INDEX_SIZEOF} )

# Following Boost conventions of prefixing 'lib' on static built libraries, across all platforms
if( ${clSPARSE_LIBRARY_TYPE} STREQUAL "STATIC" )
  set_target_properties( clSPARSE PROPERTIES PREFIX "lib" ) # global CMAKE_STATIC_LIBRARY_PREFIX
endif( )

# I think this would all be a bit easier if clBLAS started exporting its targets
# similar to what clsparse is doing
#if( MSVC_IDE )
#  set( clBLAS_LIBRARY_SHARED ${CLMATH_BLAS_ROOT}/bin/${CMAKE_SHARED_LIBRARY_PREFIX}clBLAS${CMAKE_SHARED_LIBRARY_SUFFIX} )
#  set( clblasCommand COMMAND ${CMAKE_COMMAND} -E copy_if_different ${clBLAS_LIBRARY_SHARED} ${PROJECT_BINARY_DIR}/staging/${CMAKE_CFG_INTDIR} )
#else( )
#  # UNIX based systems are using a SOLINK, link to it instead
#  set( clBLAS_LIBRARY_SOLINK ${CMAKE_SHARED_LIBRARY_PREFIX}clBLAS.2${CMAKE_SHARED_LIBRARY_SUFFIX} )
#  set( clblasCommand COMMAND ${CMAKE_COMMAND} -E create_symlink ${clBLAS_LIBRARY} ${PROJECT_BINARY_DIR}/staging/${CMAKE_CFG_INTDIR}/${clBLAS_LIBRARY_SOLINK} )
#endif( )

#add_custom_command( TARGET clSPARSE
#                   POST_BUILD
#                   ${clblasCommand}
##                   [BYPRODUCTS [files...]]
##                   [WORKING_DIRECTORY dir]
#                   COMMENT "Copying clBLAS library dependency into staging directory"
#                   VERBATIM
#                   )

# The following is cmake code to generate a config file package for clSPARSE
include( CMakePackageConfigHelpers )

set( LIB_INSTALL_DIR lib${SUFFIX_LIB} )
set( INCLUDE_INSTALL_DIR include )
set( ConfigPackageLocation ${LIB_INSTALL_DIR}/cmake/clSPARSE )

configure_package_config_file(
  clSPARSEConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/clSPARSEConfig.cmake
  INSTALL_DESTINATION ${ConfigPackageLocation}
  PATH_VARS INCLUDE_INSTALL_DIR LIB_INSTALL_DIR
)

write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/clSPARSEConfigVersion.cmake
  VERSION ${clSPARSE_VERSION}
  COMPATIBILITY SameMajorVersion
)

# Package that helps me set visibility for function names exported from shared library
GENERATE_EXPORT_HEADER( clSPARSE )

# CPack configuration; include the executable into the package
install( TARGETS clSPARSE
  EXPORT clSPARSE-Targets
  RUNTIME DESTINATION bin${SUFFIX_BIN}
  LIBRARY DESTINATION lib${SUFFIX_LIB}
  ARCHIVE DESTINATION lib${SUFFIX_LIB}
  INCLUDES DESTINATION include
)

# This generates the files that defines the import targets
install( EXPORT clSPARSE-Targets
  DESTINATION
    ${ConfigPackageLocation}
)

#Copy the config files generated by configure_package_config_file & write_basic_package_version_file
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/clSPARSEConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/clSPARSEConfigVersion.cmake
  DESTINATION
    ${ConfigPackageLocation} )

# The following installs the export definitions of the library, so the library may be properly
# dynamically linked
install( FILES
  ${CMAKE_CURRENT_BINARY_DIR}/clsparse_export.h
  DESTINATION
    include
)

=== src/tests/CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Advanced Micro Devices, Inc.
# Copyright 2015 Vratis, Ltd.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

message( STATUS "Configuring tests subdir" )

find_package( GTest REQUIRED )

# If user provides a specific boost path through command line, make sure to
# use that
if( DEFINED BOOST_ROOT OR DEFINED ENV{BOOST_ROOT} )
  set( Boost_NO_SYSTEM_PATHS ON )
  set( Boost_NO_BOOST_CMAKE ON )
endif( )

# set( Boost_DEBUG ON )
set( Boost_USE_MULTITHREADED ON )
set( Boost_DETAILED_FAILURE_MSG ON )
set( Boost_ADDITIONAL_VERSIONS 1.60.0 1.60 1.59.0 1.59 1.58.0 1.58 1.57.0 1.57 )

# On windows, Boost prefers to link statically unless the user defines BOOST_ALL_DYN_LINK
# Therefore, we prefer linking  static libs first to avoid extra #defines
set( Boost_USE_STATIC_LIBS ON )
find_package( Boost COMPONENTS program_options serialization )

# If static libraries are not found, search again for shared libraries
if( NOT Boost_FOUND )
  set( Boost_USE_STATIC_LIBS OFF )
  find_package( Boost COMPONENTS program_options serialization )
endif( )

# Unit tests requires OpenCL
# A standard FindOpenCL.cmake module ships with cmake 3.1, buy we supply our own until 3.1 becomes more prevalent
find_package( OpenCL REQUIRED )

if( BUILD_CLVERSION VERSION_EQUAL "2.0" )
    add_definitions( -DBUILD_CLVERSION=200 )
elseif( BUILD_CLVERSION VERSION_EQUAL "1.2" )
    add_definitions( -DBUILD_CLVERSION=120 )
elseif( BUILD_CLVERSION VERSION_EQUAL "1.1" )
    add_definitions( -DBUILD_CLVERSION=110 )
endif( )

#add_definitions(-D__CL_ENABLE_EXCEPTIONS)

include_directories(
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/library
  ${PROJECT_BINARY_DIR}/include
  resources
  #resources/uBLAS-linalg
  ${GTEST_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${OPENCL_INCLUDE_DIRS}
  ${CL2HPP_INCLUDE_DIRECTORY}
  )

set( TESTS_CPP
  test-blas1
  test-blas2
  test-blas3
  test-solvers
  test-conversion
  test-clsparse-utils
)

set( TESTS_C
  test_interface_c
  )

#additional headers and sources
set( src
  resources/csr_matrix_environment.cpp
  resources/opencl_utils.cpp
  resources/sparse_matrix_environment.cpp
)

set( headers
  resources/opencl_utils.h
  resources/clsparse_environment.h
  resources/matrix_utils.h
  resources/sparse_matrix_environment.h
  resources/csr_matrix_environment.h
  resources/blas1_environment.h
  resources/sparse_matrix_fill.hpp
  #resources/uBLAS-linalg/ublas_pcg.hpp
  #resources/uBLAS-linalg/precond.hpp
  #resources/uBLAS-linalg/cholesky.hpp
)

foreach( test ${TESTS_CPP} )
  add_executable( ${test} ${test}.cpp ${src} ${headers} )
  target_link_libraries( ${test} clSPARSE ${CMAKE_DL_LIBS} ${GTEST_LIBRARIES} ${Boost_LIBRARIES} ${OPENCL_LIBRARIES} )
  if( CMAKE_COMPILER_IS_GNUCXX OR ( CMAKE_CXX_COMPILER_ID MATCHES "Clang" ) )
   target_compile_options( ${test} PUBLIC -std=c++11 )
   if( CMAKE_COMPILER_IS_GNUCXX )
    target_link_libraries( ${test} pthread ) #gtest on linux brings this dependency
  endif( )
  endif( )
  set_target_properties( ${test} PROPERTIES VERSION ${clSPARSE_VERSION} )
  set_target_properties( ${test} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
  set_property( TARGET ${test} PROPERTY FOLDER "Tests" )
  if(NOT USE_SYSTEM_CL2HPP)
      add_dependencies(${test} cl2hpp)
  endif(NOT USE_SYSTEM_CL2HPP)
endforeach( )

foreach( test ${TESTS_C} )
  add_executable( ${test} ${test}.c ${headers} )
  target_link_libraries( ${test} clSPARSE ${GTEST_LIBRARIES} ${Boost_LIBRARIES} ${OPENCL_LIBRARIES} )
  if( CMAKE_COMPILER_IS_GNUCC )
    target_link_libraries( ${test} pthread ) #gtest on linux brings this dependency
  endif( )
  set_target_properties( ${test} PROPERTIES VERSION ${clSPARSE_VERSION} )
  set_target_properties( ${test} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
  set_property( TARGET ${test} PROPERTY FOLDER "Tests" )
  if(NOT USE_SYSTEM_CL2HPP)
      add_dependencies(${test} cl2hpp)
  endif(NOT USE_SYSTEM_CL2HPP)
endforeach( )

=== src/benchmarks/clsparse-bench/CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

# Benchmarks requires OpenCL
# A standard FindOpenCL.cmake module ships with cmake 3.1, buy we supply our own until 3.1 becomes more prevalent
find_package( OpenCL REQUIRED )

set( clsparse.bench.src
  src/main.cpp
  src/statisticalTimer.cpp
)

set( clsparse.bench.hdr
  include/statisticalTimer.h
  include/io-exception.hpp
  functions/clfunc_common.hpp
  functions/clfunc_xSpMdV.hpp
  functions/clfunc-xSpMdM.hpp
  functions/clfunc_xCG.hpp
  functions/clfunc_xBiCGStab.hpp
  functions/clfunc_xCoo2Csr.hpp
  functions/clfunc_xCsr2Coo.hpp
  functions/clfunc_xDense2Csr.hpp
  functions/clfunc_xCsr2Dense.hpp
  functions/clfunc_xSpMSpM.hpp
  )

include_directories(
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/library
  ${PROJECT_BINARY_DIR}/clsparseTimer
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${OPENCL_INCLUDE_DIRS}
 )

add_executable( clsparse-bench ${clsparse.bench.src} ${clsparse.bench.hdr} )
target_link_libraries( clsparse-bench ${Boost_LIBRARIES} ${OPENCL_LIBRARIES} ${CMAKE_DL_LIBS} clSPARSE )
set_target_properties( clsparse-bench PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
set_target_properties( clsparse-bench PROPERTIES VERSION ${clSPARSE_VERSION} )
set_property( TARGET clsparse-bench PROPERTY FOLDER "Benchmarks")

if(NOT USE_SYSTEM_CL2HPP)
    add_dependencies(clsparse-bench cl2hpp)
endif(NOT USE_SYSTEM_CL2HPP)

# CPack configuration; include the executable into the package
# install( TARGETS clsparse.bench
#   RUNTIME DESTINATION bin${SUFFIX_BIN}
#   LIBRARY DESTINATION lib${SUFFIX_LIB}
#   ARCHIVE DESTINATION lib${SUFFIX_LIB}
# )

=== src/benchmarks/cusparse-bench/CMakeLists.txt ===
# ########################################################################
# Copyright 2015 Advanced Micro Devices, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

find_package( CUDA REQUIRED )

set( CLIENT_SRC
  src/main.cpp
  src/statisticalTimer.cpp
  src/mm_reader.cpp
  )

set( CLIENT_HEADER
  include/statisticalTimer.h
  include/mm_reader.hpp
  include/io-exception.hpp
  functions/cufunc_common.hpp
  functions/cufunc_xSpMdV.hpp
  functions/cufunc_xCsr2dense.hpp
  functions/cufunc_xCsr2Coo.hpp
  functions/cufunc_xDense2Csr.hpp
  functions/cufunc_xCoo2Csr.hpp
  functions/cufunc_xSpMSpM.hpp
)

include_directories(
  ${CUDA_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_SOURCE_DIR}/library
  ${PROJECT_BINARY_DIR}/library
  ${CMAKE_CURRENT_SOURCE_DIR}
)

CUDA_ADD_EXECUTABLE( cusparse-bench ${CLIENT_SRC} ${CLIENT_HEADER} )
CUDA_ADD_CUBLAS_TO_TARGET( cusparse-bench )
target_link_libraries( cusparse-bench ${Boost_LIBRARIES} ${CUDA_cusparse_LIBRARY} )
set_target_properties( cusparse-bench PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/staging" )
set_target_properties( cusparse-bench PROPERTIES VERSION ${clSPARSE_VERSION} )
set_property( TARGET cusparse-bench PROPERTY FOLDER "Benchmarks")

# install( TARGETS cusparse.bench
#   RUNTIME DESTINATION bin${SUFFIX_BIN}
#   LIBRARY DESTINATION lib${SUFFIX_LIB}
#   ARCHIVE DESTINATION lib${SUFFIX_LIB}
# )

=== debian/changelog ===
clsparse (0.10.2.0-3) unstable; urgency=medium

  * Add patch fixing FTBFS with ppc64el.
    Thanks to Fernando Seiti Furusato for the patch (Closes: #844008)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 15 Nov 2016 11:55:35 +0000

clsparse (0.10.2.0-2) unstable; urgency=medium

  * Refresh patch queue.
  * Add patch fixing FTBFS with GNU Hurd and kFreeBSD.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 11 Nov 2016 16:52:52 +0000

clsparse (0.10.2.0-1) unstable; urgency=low

  * Initial release. (Closes: #794552)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 05 Nov 2016 15:45:20 +0000

=== debian/control ===
Source: clsparse
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake (>= 3.0),
               debhelper (>= 10),
               ocl-icd-opencl-dev | opencl-dev,
               opencl-clhpp-headers
Build-Depends-Indep: doxygen
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clsparse.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/clsparse.git
Homepage: https://github.com/clMathLibraries/clSPARSE

Package: libclsparse1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: OpenCL library for sparse linear algebra
 clSPARSE provides fundamental sparse operations for OpenCL, including:
 .
   * Sparse Matrix - dense Vector multiply (SpM-dV)
   * Sparse Matrix - dense Matrix multiply (SpM-dM)
   * Iterative conjugate gradient solver (CG)
   * Iterative biconjugate gradient stabilized solver (BiCGStab)
   * Dense to CSR conversions (& converse)
   * COO to CSR conversions (& converse)
   * Functions to read matrix market files in COO or CSR format
 .
 This package provides the shared library.

Package: libclsparse-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libclsparse1 (= ${binary:Version}),
         ocl-icd-opencl-dev | opencl-dev
Suggests: clsparse-doc
Description: development files for clSPARSE
 clSPARSE provides fundamental sparse operations for OpenCL, including:
 .
   * Sparse Matrix - dense Vector multiply (SpM-dV)
   * Sparse Matrix - dense Matrix multiply (SpM-dM)
   * Iterative conjugate gradient solver (CG)
   * Iterative biconjugate gradient stabilized solver (BiCGStab)
   * Dense to CSR conversions (& converse)
   * COO to CSR conversions (& converse)
   * Functions to read matrix market files in COO or CSR format
 .
 This package provides the development files.

Package: clsparse-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Description: documentation for clSPARSE
 clSPARSE provides fundamental sparse operations for OpenCL, including:
 .
   * Sparse Matrix - dense Vector multiply (SpM-dV)
   * Sparse Matrix - dense Matrix multiply (SpM-dM)
   * Iterative conjugate gradient solver (CG)
   * Iterative biconjugate gradient stabilized solver (BiCGStab)
   * Dense to CSR conversions (& converse)
   * COO to CSR conversions (& converse)
   * Functions to read matrix market files in COO or CSR format
 .
 This package provides the documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

# Hardening options.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# NOTE: Possible overlinkage with librt.
# See: https://github.com/clMathLibraries/clSPARSE/issues/195
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture --query DEB_HOST_MULTIARCH)

# NOTE: Testing is disabled (BUILD_TESTS is set to OFF), since it relies on
# remote content.
# See: https://github.com/clMathLibraries/clSPARSE/issues/194
BUILD_OPTIONS = \
	-DBUILD_BENCHMARKS=OFF \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_TESTS=OFF \
	-DSUFFIX_LIB="/$(DEB_HOST_MULTIARCH)" \
	-DUSE_SYSTEM_CL2HPP=ON

%:
	dh $@ --sourcedirectory=src

override_dh_auto_configure-arch:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_configure-indep:

override_dh_auto_build-indep:
	cd docs && doxygen Doxyfile

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_compress-indep:
	dh_compress --indep --exclude=examples

=== debian/tests/control ===
Test-Command: cd $AUTOPKGTEST_TMP;
 cmake /usr/share/doc/clsparse-doc/examples -DUSE_SYSTEM_CL2HPP=ON; make
Restrictions: allow-stderr
Depends: @, cmake, g++ | c++-compiler, opencl-clhpp-headers

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/clSPARSE-$1\.tar\.gz/ \
https://github.com/clMathLibraries/clSPARSE/tags .*/v?(\d\S*)\.tar\.gz
